/*********************** ǥ쥯ȥꡦĥ꡼ɽ ************************
 dtree.c                                                          by noocyte

	  ꤵ줿ǥ쥯ȥʲڹ¤ɸϤ˽񤯡

ˡ    dtree [{<option><directory>} ]

ץ-i<n>   Indent٥λ <n> ˤ롥
			    <n> ñ̤Ϸʸ
	    -m<n>   MarginޡȾѶοˤ <n> ˤ롥
	    -l<n>   Levelsɽڤκ翼 <n> ˤ롥
	    -r<n>   RuleѤμꤹ롥
		       0ASCIIʸѡʥǥեȡ
		       1JIS83 ΢
		       2JIS83 ɽ
	    -a	    All directories줿ǥ쥯ȥɽ롥
	    -h, -?  Helpˡɽ롥

̤  -r"<space>,<leftend>,<leftbottom>,<hline>,<vline>"
ץ	      ȤƻѤʸꤹ롥ʸȾѡ,
		      Ƕڤꡤ֤ʤ
	    -f	    Filesǥ쥯ȥǤʤեϤ롥

ˡΥեdtree ѤɤѴ塤Τ褦
	  ƥѥ뤹롥
	  (1) UNIX 4.2/4.3 BSD
	      cc dtree.c -o dtree
	  (2) MS-C Ver.5.1
	  (3) Zortech C Ver.1.06

Х    HP-UX ǡ֥ǥ쥯ȥΥ -?x ξʥ֥ǥ쥯
	  ȥ˰ưǤ뤬ɤळȤǤʤˤɽʤӥȥС
	  ⡩ˤʤ롥HP-UX  scandir ϡǥ쥯ȥɤ߽Ф
	  ʤȤˡ̵̣֤ͤ餷.Fri Mar  4, 1994

Wed Jun 21, 1989  Ver.2.1
Fri Jun 23, 1989  Ver.2.2-a ץɲä.
Thu Jun 29, 1989  Ver.2.21
Wed Oct 25, 1989  Ver.2.3UNIX 4.2/4.3BSD Version
Wed Nov 22, 1989  Ver.2.32
Wed Aug 21, 1991  Ver.2.33
Mon Apr 20, 1992  Ver.2.34HP-UX б
Wed Mar  9, 1994  Ver.2.35scandir() ˴ؤ Memory Leak 
Thu Jul 27, 1995  Ver.2.4-l ץɲ.
Mon Jul 31, 1995  Ver.2.41
Mon Aug 28, 1995  Ver.2.42
Sun Oct 15, 1995  Ver.2.5MS-DOS  -v ץɲ.
Thu Nov 23, 1995  Ver.2.51ʥܥå󥯤ɽѹ.
Wed Jan 10, 1996  Ver.2.6  MS-DOS  -c ץɲá
			   IBM-PC Ⱦѷб
Fri Aug 20, 1999  Ver.2.7 (Linux б)
Fri Mar 31, 2006  Ver.2.71 פʥץ
***************************************************************************/

#include <assert.h>
#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <signal.h>
#include <errno.h>

#ifdef __STDC__
#  include <stdarg.h>
#  define PROTOTYPE(valtype_fname, args)	valtype_fname args
#else /* __STDC__ */
#  include <varargs.h>
#  define PROTOTYPE(valtype_fname, args)	valtype_fname()
#  define const
#endif /* __STDC__ */

#ifdef unix
#  ifdef hpux
#    define SYSV
#    include <sys/dirent.h>
#  endif /* hpux */
#  include <unistd.h>
#  include <string.h>
#  include <sys/param.h>
#  include <sys/types.h>
#  include <sys/stat.h>
#  ifdef SYSV
#    include <limits.h>
#    if defined(PATH_MAX) && !defined(MAXPATHLEN)
#      define MAXPATHLEN	PATH_MAX
#    endif /* defined(PATH_MAX) && !defined(MAXPATHLEN) */
#    define GetWd(buf)	getcwd(buf, sizeof(buf))
#  else	/* SYSV */
#    define GetWd  getwd
#  endif /* SYSV */
#  define NARGS
#  define chgdsk(drive)
#  define SetWd	chdir
#  define TRUE	1
#  define FALSE	0
#  define OK    0
#  define ERROR	(-1)
#  define arraysizeof(array)	(sizeof(array) / sizeof(array[0]))
#ifdef __linux__
#  include <sys/dir.h>
#else /* __linux__ */
#  define strerror(n)		(sys_errlist[n])
   extern char *sys_errlist[];
   extern int errno, sys_nerr;
#endif /* __linux__ */
#if 0
   PROTOTYPE(int alphasort, (const struct dirent*, const struct dirent*));
   PROTOTYPE(void *malloc, (size_t));
#endif /* 0 */
#endif	/* unix */

static PROTOTYPE(void cleanup, (void));
static PROTOTYPE(void usage, (void));
static PROTOTYPE(void error, (int, const char*, ...));
static PROTOTYPE(void PrintSkeleton, (void));
static PROTOTYPE(void DfsDirTree, (const char*));
static PROTOTYPE(void PrintDirTree, (const char*));
PROTOTYPE(int main, (int, char**));


/* SUN ʤɤǤ tolower ۤʤ뤿ᡤǺ롥*/
#undef tolower
#define tolower(c)	(isupper(c) ? ((c) + ('a' - 'A')) : (c))

#ifndef S_IFLNK
#define lstat	stat
#endif	/* S_IFLNK */


/*=============================== ѿ ===============================*/

#define MAXLEVEL	(MAXPATHLEN / 2)	/* ڤκ翼 */

#ifdef unix
size_t indent = 4;		/* ٥뤴Ȥλ			*/
char ShowHiddenDirs = FALSE;	/* 줿ǥ쥯ȥɽȤ */
#endif	/* unix */

FILE *stream = NULL;		/* ϥȥ꡼		*/
unsigned LeftMargin = 0;	/* ޡ			*/
unsigned CurrentLevel;		/* õΥ٥	*/
unsigned MaxLevel = MAXLEVEL;	/* ºݤɽڤκ٥ */

/* ƥ٥θߤλǸΤΤݤ򼨤ե饰 */
char IsLast[MAXLEVEL];

/* ޥɼ¹Υȡѥ򵭲뤿ΰ */
char CurrentDir[MAXPATHLEN + 1];

/* ڤιʤ˻ѤӶʸ */
typedef struct {
  const char *space;		/* ʸʷʸ˹碌*/
  const char *vline;		/* ʸʽ			 */
  const char *hline;		/* ʸʲ			 */
  const char *leftend;		/* ʸʺü			 */
  const char *leftbottom;	/* ʸʺ			 */
} Rule_t;

Rule_t RuleTable[] = {
  {" " , "|" , "-" , "+" , "+" }, /* ASCIIʸ      */
  {"", "", "", "", ""}, /* JIS83 Ѻٷ */
  {"", "", "", "", ""}, /* JIS83  */
};

/* ºݤ˻Ѥ Rule_t ¤ΤؤΥݥ */
Rule_t *rule = &RuleTable[0];


/*================ λ顼ˡɽʤ ================*/

/*-------------------- λCTRL-C ؿ--------------------*/
static void cleanup()
{
  SetWd(CurrentDir);		/* ǽΥǥ쥯ȥ롥*/
  exit(0);			/* ｪλ */
}

/* ޥ̾ */
#ifdef MSC
char progname[9];	/* ޥ̾ */
#else	/* MSC */
char *progname;		/* ޥ̾ */
#endif	/* MSC */

const char * const title[] = {
  "Directory Tree Display Utility, Version 2.71",
  "  by noocyte (Fri Mar 31, 2006)"
};

/*----------------------------- ˡɽ -----------------------------*/
const char * const UsageText[] = {
  "Usage  : %s {option | directory} ...\n",
  "Options: -m<n>\tMargin: set left margin to <n>.\n",
  "\t -i<n>\tIndent: set indent to <n>.\n",
  "\t -l<n>\tLevels: set max. level to <n>.\n",
  "\t -r<n>\tRule: <n> specifies the following rule set.\n",
  "\t\t   0: Generic ASCII character. (default)\n",
  "\t\t   1: JIS83 thin  em-rule.\n",
  "\t\t   2: JIS83 thick em-rule.\n",
  "\t -a\tAll directories: also display hidden directories.\n",
  "\t -h\tHelp: display this text.\n"
};

/*--------------------- ȥȻˡɽ롥----------------------*/
static void usage()
{
  unsigned i;

  for(i = 0;  i < arraysizeof(title);  i++)
    fprintf(stderr, "%s\n", title[i]);
  for(i = 0;  i < arraysizeof(UsageText);  i++)
    fprintf(stderr, UsageText[i], progname);
}

/*--------------------------------------------------------------------------
  void error(exitCode, format, [arg1, ])
	int exitCode;
	const char *format;
ǽ  顼åȻˡɽꤵ줿λɤǽλ롥
--------------------------------------------------------------------------*/
#ifdef __STDC__

void error(int exitCode, const char *format, ...)
{
  va_list args;

  fprintf(stderr, "%s: ", progname);
  if(format == NULL) {
    /* formatNULLξϡƥΥ顼åϤ롥*/
    fprintf(stderr, "%s\n", strerror(errno));
  } else {
    va_start(args, format);
    vfprintf(stderr, format, args);
    va_end(args);
  }
  usage();
  SetWd(CurrentDir);		/* ǽΥǥ쥯ȥ롥*/
  exit(exitCode);
}

#else /* __STDC__ */

static void error(va_alist)
va_dcl
{
  int exitCode;
  const char *format;
  va_list args;

  va_start(args);
  exitCode = va_arg(args, int);
  format = va_arg(args, const char*);
  fprintf(stderr, "%s: ", progname);
  if(format == NULL) {
    /* formatNULLξϡƥΥ顼åϤ롥*/
    fprintf(stderr, "%s\n", sys_errlist[errno]);
  } else vfprintf(stderr, format, args);
  usage();
  SetWd(CurrentDir);		/* ǽΥǥ쥯ȥ롥*/
  exit(exitCode);
  va_end(args);
}

#endif /* __STDC__ */

/*---------------------------- ڤιʤν ------------------------------
ǽ  κ¦ˡꤵ줿Ѥƹʤɽ롥
  ߤνϷ֤ϺüˤʤФʤʤ
  Wed May 10, 1989  
--------------------------------------------------------------------------*/
static void PrintSkeleton()
{
  unsigned level_1, lev, i;

  /* ޡLeftMargin ĤȾѶϤ*/
  for(i = 1;  i <= LeftMargin;  i++) fputc(' ', stream);

  if(CurrentLevel > 0) {
    level_1 = CurrentLevel - 1;
    for(lev = 0;  lev < level_1;  lev++) {
      fputs(IsLast[lev] ? rule->space : rule->vline, stream);
      /* indent1 ĤζϤ롥*/
      for(i = 1;  i < indent;  i++) fputs(rule->space, stream);
    }
    fputs(IsLast[level_1] ? rule->leftbottom : rule->leftend , stream);
    for(i = 1;  i < indent;  i++) fputs(rule->hline, stream);
/*  fputs(rule->space, stream); */
  }
}


#ifdef unix
#if 0
/*--------------------------------------------------------------------------
ؿ͡ǥ쥯ȥꡦȥ dp ֥ǥ쥯ȥޤϥǥ쥯ȥؤΥ
	󥯤ǤȤΤȤ˸¤꿿֤
Wed Oct 25, 1989  
Wed Nov 22, 1989  ShowHiddenDirs ե饰ξ硤줿ǥ쥯ȥФ
		  Ƶ֤褦ˤ
Wed Mar  9, 1994  DEBUG
--------------------------------------------------------------------------*/
int IsSubDir(dp)
struct direct *dp;
{
  struct stat st;

  /* ǥ쥯ȥꡦȥ꤬.ɤޤϡ..ɤʤе֤*/
  if((strcmp(dp->d_name, ".") == 0) || (strcmp(dp->d_name, "..") == 0))
    return FALSE;
  return ((stat(dp->d_name, &st) != ERROR) &&
	  ((st.st_mode & S_IFMT) == S_IFDIR) &&
	  (ShowHiddenDirs || (dp->d_name[0] != '.')));
}
#endif /* 0 */

typedef struct StringElement StringElement_t;

struct StringElement {
  StringElement_t *next;
  char string[sizeof(((struct dirent*)NULL)->d_name)];
};

PROTOTYPE(char **GetSubdirs, (unsigned *n_subdirs));
PROTOTYPE(void FreeSubdirs, (char **subdirs, unsigned n_subdirs));
PROTOTYPE(int CompareStrPtrs,
          (const char * const *strptr1, const char * const *strptr2));

int CompareStrPtrs(strptr1, strptr2)
const char * const *strptr1;
const char * const *strptr2;
{
  return strcmp(*strptr1, *strptr2);
}


char **GetSubdirs(nSubDirs)
unsigned *nSubDirs;
{
  struct stat st;
  DIR *dirstream;
  struct dirent *entry;
  StringElement_t *element;
  StringElement_t *list = NULL;
  const char *name;
  char **subdirs = NULL;
  char **p;
  unsigned _nSubDirs = 0;

  if((dirstream = opendir(".")) != NULL) {
    while((entry = readdir(dirstream)) != NULL) {
      name = entry->d_name;
      if((stat(name, &st) == OK) && S_ISDIR(st.st_mode)) {
        /* entry ǥ쥯ȥޤϥǥ쥯ȥؤ
         * ܥå󥯤ξ
         */
        if((name[0] == '.') &&
           ((name[1] == '\0') ||                       /* "."  ξ */
            ((name[1] == '.') && (name[2] == '\0')) || /* ".." ξ */
            !ShowHiddenDirs)) {
          /* name  "."".." ξ硤뤤 "." ǻϤޤꡤ
           * եɽʤ硧̵뤹롥
           */
	} else {
          /* name ݻ StringElement_t list Ƭɲá*/
          size_t size = offsetof(StringElement_t, string[1]) + strlen(name);
          element = malloc(size);
          if(element == NULL) goto Error;
          strcpy(element->string, name);
          element->next = list;
          list = element;
          _nSubDirs++;
	}
      }
    }
    closedir(dirstream);

    /* list γʸؤΥݥ󥿤롥*/
    if((subdirs = malloc(sizeof(*subdirs) * _nSubDirs)) == NULL) goto Error;
    *nSubDirs = _nSubDirs;
    p = subdirs;
    for(element = list;  element != NULL;  element = element->next)
      *p++ = element->string;

    /* ʸɽ˥Ȥ롥*/
    qsort(subdirs, _nSubDirs, sizeof(*subdirs),
          (PROTOTYPE(int (*), (const void*, const void*)))CompareStrPtrs);
  }
  return subdirs;

 Error:
  while(list != NULL) {
    element = list;
    list = element->next;
    free(element);
  }
  if(subdirs != NULL) free(subdirs);
  *nSubDirs = 0;
  return NULL;
}

void FreeSubdirs(subdirs, nSubDirs)
char **subdirs;
unsigned nSubDirs;
{
  char **p = subdirs;
  char **end = subdirs + nSubDirs;
  char *string;

  while(p < end) {
    string = *p++;
    assert(string != NULL);
    free(string - offsetof(StringElement_t, string));
  }
  free(subdirs);
}
#endif	/* unix */

/*--------------------------------------------------------------------------
ǽ  ǥ쥯ȥꡦĥ꡼ķõ롥
--------------------------------------------------------------------------*/
#ifdef unix
static void DfsDirTree(dirEntry)
const char *dirEntry;
{
  static char path[MAXPATHLEN + 1];
  struct stat st;
  mode_t type;
  char *cwd;

  if(lstat(dirEntry, &st) == OK) {
    PrintSkeleton();
    type = st.st_mode & S_IFMT;
    switch(type) {
    case S_IFDIR: /* dirEntry ֥ǥ쥯ȥξ */
      /* ֥ǥ쥯ȥ˰ܤˡ֤߰ cwd ˵롥*/
      GetWd(path);
      if((cwd = strdup(path)) == NULL) error(1, NULL);
      /* ֥ǥ쥯ȥ˰ܤ롥*/
      if(SetWd(dirEntry) == ERROR) {
	/* ֥ǥ쥯ȥ˰ưǤʤ */
	fprintf(stream, "%s (Error: %s)\n", dirEntry, strerror(errno));
      } else {			/* dirEntry ʲι¤Ϥ롥*/
	GetWd(path);
	fputs((CurrentLevel == 0) ? path : dirEntry, stream);
	if(CurrentLevel >= MaxLevel)
	  fputc('\n', stream);
	else {
	  char **subdirs;
	  unsigned nSubDirs;

	  /* ֥ǥ쥯ȥΥȥ롥*/
	  if((subdirs = GetSubdirs(&nSubDirs)) == NULL) {
	    fprintf(stream, " (Error: Can't get subdirs: %s)\n",
		    strerror(errno));
	    fprintf(stderr, "Path:%s\n", path);
	  } else fputc('\n', stream);
	  if(nSubDirs > 0) {
	    unsigned level = CurrentLevel++;
	    unsigned last = nSubDirs - 1;
	    unsigned i;

	    for(i = 0;  i <= last;  i++) {
	      /* ǸΥ֥ǥ쥯ȥ꤫ݤĴ١
	       * ͤ IsLast[level] 롥
	       */
	      IsLast[level] = (i == last);
	      DfsDirTree(subdirs[i]);
	    }
	    CurrentLevel = level;
	  }
	  FreeSubdirs(subdirs, nSubDirs);
	}
      }
      SetWd(cwd);
      free(cwd);
      break;
#ifdef S_IFLNK
    case S_IFLNK: /* ǥ쥯ȥؤΥ󥯤ξ */
      {
	int n;
	if((n = readlink(dirEntry, path, sizeof(path))) == ERROR)
	  fprintf(stream, "%s (link to directory, Error: %s)\n",
		  dirEntry, strerror(errno));
	else {
	  path[n] = '\0';
	  fprintf(stream, "%s -> %s\n", dirEntry, path);
	}
      }
      break;
#endif /* S_IFLNK */
#if 0
    default: assert(FALSE);
#endif /* 0 */
    }
  }
}
#endif	/* unix */

/*--------------------------------------------------------------------------
ǽ  dirEntry ʲϤ롥
--------------------------------------------------------------------------*/
static void PrintDirTree(dirEntry)
const char *dirEntry;
{
  struct stat st;

  if(stat(dirEntry, &st) == ERROR) {
Error:
    fprintf(stderr, "%s: %s\n", dirEntry, strerror(errno));
  } else if(!S_ISDIR(st.st_mode)) {
    errno = ENOTDIR;
    goto Error;
  } else {
    fputc('\n', stream);
    GetWd(CurrentDir);		/* ȡǥ쥯ȥ򵭲 */
    CurrentLevel = 0;
    DfsDirTree(dirEntry);
    SetWd(CurrentDir);		/* Υǥ쥯ȥ롥*/
  }
}


/*================================ ᥤ ================================*/

int main(argc, argv)
int  argc;
char *argv[];
{
  unsigned nDirArgs;
  int x, i;

  stream = stdout;

  /* ޥ̾ progname 롥*/
#ifdef MSC
  _splitpath(StringToUpper(argv[0]), NULL, NULL, progname, NULL);
#else	/* MSC */
  progname = argv[0];
#endif	/* MSC */
  GetWd(CurrentDir);			/* ȡǥ쥯ȥ򵭲 */

  /* CTRL-C ߽ */
  signal(SIGINT, (PROTOTYPE(void (*), (int)))cleanup);

  /* ץ롥*/
  for(i = 1;  i < argc;  i++) {
    if((*argv[i]) == '-') {
      switch(tolower(argv[i][1])) {
      case 'i': indent = atoi(&argv[i][2]);
		break;
      case 'l': if((sscanf(&argv[i][2], "%u", &MaxLevel) == 1) &&
		   (MaxLevel > 0))
		  MaxLevel--;
		else
		  error(1, "MaxLevel <= 0\n");
		if(MaxLevel > MAXLEVEL) MaxLevel = MAXLEVEL;
		break;
      case 'm': LeftMargin = atoi(&argv[i][2]);
		break;
      case 'r': if((sscanf(&argv[i][2], "%d", &x) == 1) &&
		   (0 <= x) && (x < arraysizeof(RuleTable)))
		  rule = &RuleTable[x];
		else switch(tolower(argv[i][2])) {
#if 0
		case '"': /* unimplemented */
#endif /* 0 */
		default:
		  error(1, "invalid argument '%s' for -r option.\n",
			&argv[i][2]);
		}
		break;
      case 'a':
#ifdef unix
		ShowHiddenDirs = TRUE;
#endif	/* unix */
		break;
      case 'h': usage();
		exit(0);
      default : error(1, "unknown option '%s'\n", argv[i]);
		break;
      }
    }
  }

  /* ǥ쥯ȥꤹοnDirArgs 롥*/
  for(nDirArgs = 0, i = 1;  i < argc;  ++i) {
    if(*argv[i] != '-') nDirArgs++;
  }
  if(nDirArgs > 0) {
    /* ꤵ줿ǥ쥯ȥγơ롥*/
    for(i = 1;  i < argc;  i++) {
      if(*argv[i] != '-')
	PrintDirTree(argv[i]);
    }
  }
  /* ͿƤʤСȡ
   * ǥ쥯ȥȤڤϤ롥
   */
  else PrintDirTree(".");
  cleanup();
  return 0;
}
